.\" $Header: xf.man,v 1.1 89/11/25 13:44:21 shea Exp $
.TH XF 1X "17 July 1988" "X Version 11"
.SH NAME
\fIxf\fR \- X window filename tool
.SH SYNOPSIS
.B xf
[-a] [\fIdirectory_name\fR ...]
.SH DESCRIPTION
The
.I xf
program is a visual tool for generating a collection of filenames
from a variety of directories,
typically as the command-line input to a program like rm(1) or
chmod(1).

.I Xf
has two different window types, a directory window and a
dialog window.

The directory window is labeled with a directory name, and
the directory's files are displayed in a matrix
(the \fISet\fR widget);
any number of entries may
be highlighted by calling the \fISet\fR widget's
Toggle() translation function (bound to None<Btn1Down> by default).
Note that this is different from the Athena List widget (from which
\fISet\fR was derived).  Highlighting a \fISet\fR widget entry has nothing
to do with the Xt selection mechanism -- no selection is exported
from \fIxf\fR.
The directory window has four buttons:
"Up" which opens a directory window on the next higher
directory; "Done" which causes the set of all highlighted file
names in all current \fIxf\fR windows to appear on stdout,
and the program to exit; "Quit" which simply causes the program to exit;
and "Enter Filename" which causes a pathname-prompt window to be opened.

The pathname-prompt window allows
entry of an absolute or relative
(to the directory from which \fIxf\fR was called)
pathname, and
causes an \fIxf\fR window to be opened in the specified directory.
It has only one button, "Confirm" which is pressed when the
typed in filename is correct.  Typing Return within the prompt
window has the same effect as pressing the "Confirm" button.
The default behavior of the Text child of the Dialog widget
is determined by the app-defaults file (see below).
.SH OPTIONS
.I Xf
accepts all of the standard X Toolkit command line options along with the 
additional options listed below:
.TP 8
.B \-a
File names that begin with '.' will not be suppressed.
This is reminiscent of ls(1).
.PP
The following standard X Toolkit command line arguments are commonly used with 
.I xf:
.TP 8
.B \-bg \fIcolor\fP
This option specifies the color to use for the background of the window.  
The default is \fIwhite\fP.
.TP 8
.B \-bd \fIcolor\fP
This option specifies the color to use for the border of the window.
The default is \fIblack\fP.
.TP 8
.B \-bw \fInumber\fP
This option specifies the width in pixels of the border surrounding the window.
.TP 8
.B \-fg \fIcolor\fP
This option specifies the color to use for displaying text.  The default is 
\fIblack\fP.
.TP 8
.B \-fn \fIfont\fP
This option specifies the font to be used for displaying normal text.  The
default is \fI6x10\fP.
.TP 8
.B \-rv
This option indicates that reverse video should be simulated by swapping
the foreground and background colors.
.TP 8
.B \-display \fIhost\fP:\fIdisplay\fP
This option specifies the X server to contact.
.TP 8
.B \-xrm \fIresourcestring\fP
This option specifies a resource string to be used.
.SH X DEFAULTS
The \fIxf\fR directory window is based upon the 
.I Set
widget, a variant of the List widget (from the Athena widget set).
The directory window consists of a Form widget ("form") containing
a Label widget ("label"),
a \fISet\fR widget ("set"),
and four Command widgets ("up", "quit", "done", "dir_name").
The dialog window is a Dialog widget
("dialog") with a child Command widget ("confirm").
.I Xf
understands all of the core and relevant Athena
resource names and classes for both of its window types.
The \fISet\fR widget recognizes the following additional names and classes:
.PP
.TP 8
.B columnSpacing (\fPclass\fB Spacing)
Specifies the space between columns in the \fISet\fR widget.
The default is 6 in the \fISet\fR widget, 10 in \fIxf\fR.
.TP 8
.B rowSpacing (\fPclass\fB Spacing)
Specifies the space between rows in the \fISet\fR widget.
The default is 4 in the \fISet\fR widget, 4 in \fIxf\fR.
.TP 8
.B defaultColumns (\fPclass\fB Columns)
Specifies the number of columns the contents of the
\fISet\fR widget will be displayed in.
.TP 8
.B forceColumns (\fPclass\fB Boolean)
Force the \fISet\fR widget to use exactly defaultColumns columns.
.PP
The default resources for \fIxf\fR are:
.EX
!
! *** The dialog.label string must be padded with
!	blanks to get the right effect from the funky Dialog widget...
!
Xf*dialog.label: \\
Enter Directory Name                                            *
Xf*dialog.maximumLength:	128
Xf*dialog.confirm.label:	Confirm
Xf*value.translations: #replace\n\\
    Ctrl<Key>U: beginning-of-line() kill-to-end-of-line()\n\\
    Ctrl<Key>H: delete-previous-character()\n\\
    <Key>Delete: delete-previous-character()\n\\
    <Key>Return: \n\\
    <Key>: insert-char()
Xf*confirm.accelerators: #override \n\\
    <Key>Return: set() notify() unset()
!
! The directory box...
!
Xf*form.set.defaultColumns:	5
Xf*form.set.columnSpacing:	10
Xf*form.set.verticalSet:	on
!
! What the Set widget should do...
!
Xf*form.set.translations:\\
    None <Btn1Down>:   Toggle()\n\\
    None <Btn2Down>:   Toggle()\n\\
    None <Btn2Up>:   Toggle() NotifyB()
!
Xf*form.up.label:		Up
Xf*form.quit.label:		Quit
Xf*form.done.label:		Done
Xf*form.dir_name.label:		Enter Directory Name
!
!
! *** The dialog.label string must be padded with
!	blanks to get the right effect from the funky Dialog widget...
!
Xf*dialog.label: \\
Enter Directory Name                                            *
Xf*dialog.maximumLength:	128
Xf*dialog.confirm.label:	Confirm
Xf*value.translations: #replace\n\\
    Ctrl<Key>U: beginning-of-line() kill-to-end-of-line()\n\\
    Ctrl<Key>H: delete-previous-character()\n\\
    <Key>Delete: delete-previous-character()\n\\
    <Key>Return: \n\\
    <Key>: insert-char()
Xf*confirm.accelerators: #override \n\\
    <Key>Return: set() notify() unset()
!
! The directory box...
!
Xf*form.set.defaultColumns:	5
Xf*form.set.columnSpacing:	10
Xf*form.set.verticalSet:	on
!
! What the Set widget should do...
!
Xf*form.set.translations:\\
    None <Btn1Down>:   Toggle()\n\\
    None <Btn2Down>:   Toggle()\n\\
    None <Btn2Up>:   Toggle() NotifyB()
!
Xf*form.up.label:		Up
Xf*form.quit.label:		Quit
Xf*form.done.label:		Done
Xf*form.dir_name.label:		Enter Directory Name
!
.EE
.SH X TRANSLATIONS
The \fISet\fR widget supports the following translation functions
.TP 8
.B Toggle()
Toggles the foreground and background colors on the
entry in the \fISet\fR widget element which was clicked on.
.TP 8
.B NotifyA(), NotifyB(), NotifyC()
Different callbacks may be bound to each of these functions,
they have no other side effects.
.I Xf
uses NotifyB() to open the subdirectory which was clicked on.
An error is printed if the clicked-on entry was not a subdirectory.
.PP
The default translations are set in the resource defaults
described above.
.SH "SEE ALSO"
ls(1), X(1), xrdb(1), Athena List, Command, Label, and Dialog widgets
.SH BUGS
.I Xf
should support the selection mechanism.  Somehow.
.br
Very large directories can cause the window to grow right off the
screen -- rather inconvenient since then the buttons disappear.
.SH COPYRIGHT
Copyright 1989 Regents of the University of California.
Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies.  The University of California
makes no representations about the suitability of this
software for any purpose.  It is provided "as is" without
express or implied warranty.
.PP
Some parts of \fIxf\fR are copyright MIT, 1988.
.SH AUTHORS
Gary Shea (UC Berkeley)
.br
Chris D. Peterson (MIT-Athena)


